import { HttpStatus } from "@nestjs/common";
import { JwtService } from "@nestjs/jwt";
import { UsersService } from "./users/users.service";
import { WusergrpService } from "./wusergrp/wusergrp.service";
import { UtilityService } from "../common/service/utility.service";
export declare class AuthService {
    private jwtService;
    private userService;
    private utilityService;
    private readonly userGroupService;
    constructor(jwtService: JwtService, userService: UsersService, utilityService: UtilityService, userGroupService: WusergrpService);
    validateUser(username: string, pass: string): Promise<any>;
    findUser(username: string): Promise<any>;
    tokenDecode(token: string): Promise<any>;
    login(user: any): Promise<{
        statusCode: HttpStatus;
        message: string;
        success: boolean;
        access_token: string;
    } | {
        statusCode: HttpStatus;
        success: boolean;
        message: string;
        access_token?: undefined;
    }>;
}
