import { UsersService } from "./users.service";
import { CreateUserDto } from "./dto/create-user.dto";
import { UpdateUserDto } from "./dto/update-user.dto";
import { User } from "./entities/user.entity";
import { ChangePasswordDto } from "./dto/change-password.dto";
import { AuthService } from "../auth.service";
import { BaseController, UtilityService } from "../../common";
export declare class UsersController extends BaseController<User> {
    private readonly s;
    private readonly authService;
    private utilityService;
    constructor(s: UsersService, authService: AuthService, utilityService: UtilityService);
    createUser(CreateUserDto: CreateUserDto): Promise<unknown>;
    updateUser(id: number, UpdateUserDto: UpdateUserDto): Promise<unknown>;
    changePassword(changePaswwordDto: ChangePasswordDto, request: any): Promise<unknown>;
}
