"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersController = void 0;
const common_1 = require("@nestjs/common");
const users_service_1 = require("./users.service");
const create_user_dto_1 = require("./dto/create-user.dto");
const update_user_dto_1 = require("./dto/update-user.dto");
const change_password_dto_1 = require("./dto/change-password.dto");
const auth_service_1 = require("../auth.service");
const common_2 = require("../../common");
let UsersController = class UsersController extends common_2.BaseController {
    constructor(s, authService, utilityService) {
        super(s);
        this.s = s;
        this.authService = authService;
        this.utilityService = utilityService;
    }
    createUser(CreateUserDto) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const hashedPassword = yield this.utilityService.hashFunction(CreateUserDto.password);
                let UserDto = Object.assign(Object.assign({}, CreateUserDto), { creatorLog: true, password: hashedPassword });
                return this.s.create(UserDto, {});
            }
            catch (error) {
                console.log('ERROR IN CORE', error);
            }
        });
    }
    updateUser(id, UpdateUserDto) {
        return __awaiter(this, void 0, void 0, function* () {
            let user = null;
            let UserDto = Object.assign(Object.assign({}, UpdateUserDto), { updatorLog: true });
            const record = yield this.s.findOne(id);
            return this.s.update(user, record, UserDto);
        });
    }
    changePassword(changePaswwordDto, request) {
        return __awaiter(this, void 0, void 0, function* () {
            const token = request.headers.authorization;
            const user = yield this.authService.tokenDecode(token);
            return this.s.changePassword(changePaswwordDto, user);
        });
    }
};
__decorate([
    (0, common_1.Post)("/create-user"),
    __param(0, (0, common_1.Body)(common_1.ValidationPipe)),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_dto_1.CreateUserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "createUser", null);
__decorate([
    (0, common_1.Put)("update-user/:id"),
    __param(0, (0, common_1.Param)("id")),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, update_user_dto_1.UpdateUserDto]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "updateUser", null);
__decorate([
    (0, common_1.Post)("change-password"),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Request)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [change_password_dto_1.ChangePasswordDto, Object]),
    __metadata("design:returntype", Promise)
], UsersController.prototype, "changePassword", null);
UsersController = __decorate([
    (0, common_1.Controller)("users"),
    __metadata("design:paramtypes", [users_service_1.UsersService,
        auth_service_1.AuthService,
        common_2.UtilityService])
], UsersController);
exports.UsersController = UsersController;
