"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersService = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("../../common/constants");
const user_entity_1 = require("./entities/user.entity");
const common_2 = require("../../common");
let UsersService = class UsersService extends common_2.BaseService {
    constructor(user, model) {
        super(model);
        this.user = user;
        this.model = model;
    }
    findByUsername(username) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.user
                .findOne({
                where: { email: username },
            })
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                if (result) {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "success",
                        success: true,
                        result,
                    };
                }
                else {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "No Data Found",
                        success: false,
                        result,
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    success: false,
                    error,
                };
            });
        });
    }
    changePassword(changePasswordDto, user) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.user
                .findOne({
                where: { id: user.id },
            })
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                let user = result.get({ plain: true });
                console.log(user);
                console.log(changePasswordDto);
                if (user) {
                    console.log(user.password === changePasswordDto.current_password, user.password, changePasswordDto.current_password);
                    if (user.password === changePasswordDto.current_password) {
                        console.log("Going to change password");
                        yield result.update({ password: changePasswordDto.new_password });
                        return {
                            success: true,
                            statusCode: common_1.HttpStatus.OK,
                            message: "success",
                            result: "Password changed successfully",
                        };
                    }
                    else {
                        console.log("wrong 1");
                        return {
                            success: false,
                            statusCode: common_1.HttpStatus.BAD_REQUEST,
                            message: "failed",
                            result: "Password changing failed. Incorrect Password",
                        };
                    }
                }
                else {
                    console.log("wrong 2");
                    return {
                        statusCode: common_1.HttpStatus.BAD_REQUEST,
                        message: "failed",
                        result: "Password changing failed. No user Found",
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    error,
                };
            });
        });
    }
};
UsersService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.CORE_USERS)),
    __param(1, (0, common_1.Inject)(constants_1.CORE_USERS)),
    __metadata("design:paramtypes", [Object, user_entity_1.User])
], UsersService);
exports.UsersService = UsersService;
