"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseController = void 0;
const common_1 = require("@nestjs/common");
const find_options_dto_1 = require("../options/find-options.dto");
class BaseController {
    constructor(s) {
        this.service = s;
    }
    findAll(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const options = new find_options_dto_1.CaptureRecordIndexDto(params).getOptions();
            return yield this.service
                .findAll(options)
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                if (result) {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "success",
                        success: true,
                        result,
                    };
                }
                else {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "No Data Found",
                        success: false,
                        result,
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    success: false,
                    error,
                };
            });
        });
    }
    findOne(id) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(id);
            return yield this.service
                .findOne(id)
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                console.log(id, result);
                if (result) {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "success",
                        success: true,
                        result,
                    };
                }
                else {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "No Data Found",
                        success: false,
                        result,
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    success: false,
                    error,
                };
            });
        });
    }
    create(body, req) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.service
                .create(body, {})
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                if (result) {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "success",
                        success: true,
                        result,
                    };
                }
                else {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "No Data Found",
                        success: false,
                        result,
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    success: false,
                    error,
                };
            });
        });
    }
    update(id, body, req) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = req.user;
            const record = yield this.service.findOne(id);
            if (!record)
                throw new common_1.NotFoundException();
            return yield this.service
                .update(user, record, body)
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                if (result) {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "success",
                        success: true,
                        result,
                    };
                }
                else {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "No Data Found",
                        success: false,
                        result,
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    success: false,
                    error,
                };
            });
        });
    }
    delete(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const record = yield this.service.findOne(id);
            if (!record)
                return {
                    statusCode: common_1.HttpStatus.NOT_FOUND,
                    message: "failed",
                };
            return yield this.service
                .remove(id)
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                if (result) {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "success",
                        success: true,
                        result,
                    };
                }
                else {
                    return {
                        statusCode: common_1.HttpStatus.OK,
                        message: "No Data Found",
                        success: false,
                        result,
                    };
                }
            }))
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    success: false,
                    error,
                };
            });
        });
    }
}
__decorate([
    (0, common_1.Get)(),
    __param(0, (0, common_1.Query)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [find_options_dto_1.CaptureRecordIndexDto]),
    __metadata("design:returntype", Promise)
], BaseController.prototype, "findAll", null);
__decorate([
    (0, common_1.Get)("/:id"),
    __param(0, (0, common_1.Param)("id")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], BaseController.prototype, "findOne", null);
__decorate([
    (0, common_1.Post)(),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Request)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], BaseController.prototype, "create", null);
__decorate([
    (0, common_1.Put)(":id"),
    __param(0, (0, common_1.Param)("id")),
    __param(1, (0, common_1.Body)()),
    __param(2, (0, common_1.Request)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object, Object]),
    __metadata("design:returntype", Promise)
], BaseController.prototype, "update", null);
__decorate([
    (0, common_1.Delete)(":id"),
    __param(0, (0, common_1.Param)("id")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], BaseController.prototype, "delete", null);
exports.BaseController = BaseController;
