"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseConnection = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const user_entity_1 = require("../../auth/users/entities/user.entity");
class DatabaseConnection {
    dbConnection(config, models) {
        return __awaiter(this, void 0, void 0, function* () {
            const inetial_models = [user_entity_1.User];
            const tables = inetial_models.concat(models);
            try {
                const sequelize = new sequelize_typescript_1.Sequelize(config);
                yield sequelize
                    .authenticate()
                    .then(() => {
                    console.log("Connection has been established successfully.");
                })
                    .catch((err) => {
                    console.error("Unable to connect to the database:", err);
                });
                sequelize.addModels(tables);
            }
            catch (error) {
                console.error("Unable to connect to the databases:", error);
            }
        });
    }
}
exports.DatabaseConnection = DatabaseConnection;
