"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreMenuRolesController = void 0;
const common_1 = require("@nestjs/common");
const core_menu_roles_service_1 = require("./core-menu-roles.service");
const menus_dto_1 = require("./dto/menus.dto");
const common_2 = require("../../common");
const auth_service_1 = require("../../auth/auth.service");
let CoreMenuRolesController = class CoreMenuRolesController extends common_2.BaseController {
    constructor(coreMenuRolesService, s, authService) {
        super(s);
        this.coreMenuRolesService = coreMenuRolesService;
        this.s = s;
        this.authService = authService;
    }
    createMenuRoles(params, request) {
        return __awaiter(this, void 0, void 0, function* () {
            const token = request.headers.authorization;
            const user = yield this.authService.tokenDecode(token);
            return yield this.coreMenuRolesService
                .createMenus(params, user)
                .then((result) => {
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "success",
                    result,
                };
            })
                .catch((error) => {
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    message: "failed",
                    error,
                };
            });
        });
    }
};
__decorate([
    (0, common_1.Post)("create-menu-roles"),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Request)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [menus_dto_1.MenusDto, Object]),
    __metadata("design:returntype", Promise)
], CoreMenuRolesController.prototype, "createMenuRoles", null);
CoreMenuRolesController = __decorate([
    (0, common_1.Controller)("core-menu-roles"),
    __metadata("design:paramtypes", [core_menu_roles_service_1.CoreMenuRolesService,
        core_menu_roles_service_1.CoreMenuRolesService,
        auth_service_1.AuthService])
], CoreMenuRolesController);
exports.CoreMenuRolesController = CoreMenuRolesController;
