"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreMenusService = void 0;
const common_1 = require("@nestjs/common");
const sequelize_1 = require("sequelize");
const utility_service_1 = require("../../common/service/utility.service");
const constants_1 = require("../../common/constants");
const core_menu_entity_1 = require("./entities/core-menu.entity");
const common_2 = require("../../common");
let CoreMenusService = class CoreMenusService extends common_2.BaseService {
    constructor(model, coreMenus, coreMenuRoles, corePageDefinitions, coreModelDetails, coreUserRoles, utilityService) {
        super(model);
        this.model = model;
        this.coreMenus = coreMenus;
        this.coreMenuRoles = coreMenuRoles;
        this.corePageDefinitions = corePageDefinitions;
        this.coreModelDetails = coreModelDetails;
        this.coreUserRoles = coreUserRoles;
        this.utilityService = utilityService;
    }
    restore(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const menus = yield this.coreMenus.restore({
                where: { id: id },
            });
            if (menus) {
                return menus;
            }
            else {
                return { status: "failed", message: "Not Found" };
            }
        });
    }
    getMenus(user) {
        return __awaiter(this, void 0, void 0, function* () {
            const role = yield this.coreUserRoles.findOne({
                where: {
                    user_id: user.id,
                },
            });
            const menu_ids = [];
            if (role) {
                const menus = yield this.coreMenuRoles.findAll({
                    where: {
                        role_id: role.role_id,
                    },
                });
                menus.forEach((menu) => {
                    menu_ids.push(menu.menu_id);
                });
                if (menu_ids[0]) {
                    return yield this.menus(menu_ids, null, 1);
                }
                else {
                    return [];
                }
            }
            else {
                return [];
            }
        });
    }
    menus(menu_ids, id, step_count) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.coreMenus
                .findAll({
                where: {
                    step: step_count,
                    id: { [sequelize_1.Op.in]: menu_ids },
                    header_id: id,
                },
                include: [
                    {
                        model: this.coreModelDetails,
                        as: 'model',
                        attributes: ['id', 'name'],
                    },
                    {
                        model: this.corePageDefinitions,
                        as: 'page',
                        attributes: ['id', 'path', 'name'],
                    },
                ],
            })
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                let sub_menus;
                if (result.length > 0) {
                    step_count++;
                    return yield Promise.all(result.map((element) => __awaiter(this, void 0, void 0, function* () {
                        sub_menus = yield this.menus(menu_ids, element.id, step_count);
                        return Object.assign(Object.assign({}, element.dataValues), { sub_menus });
                    })));
                }
                else {
                    sub_menus = null;
                }
            }));
        });
    }
};
CoreMenusService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.CORE_MENUS)),
    __param(1, (0, common_1.Inject)(constants_1.CORE_MENUS)),
    __param(2, (0, common_1.Inject)(constants_1.CORE_MENU_ROLES)),
    __param(3, (0, common_1.Inject)(constants_1.CORE_PAGE_DEFINITIONS)),
    __param(4, (0, common_1.Inject)(constants_1.CORE_MODEL_DETAILS)),
    __param(5, (0, common_1.Inject)(constants_1.CORE_USER_ROLES)),
    __metadata("design:paramtypes", [core_menu_entity_1.CoreMenu, Object, Object, Object, Object, Object, utility_service_1.UtilityService])
], CoreMenusService);
exports.CoreMenusService = CoreMenusService;
