"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreScriptsService = void 0;
const common_1 = require("@nestjs/common");
const common_2 = require("../../common");
const constants_1 = require("../../common/constants");
const core_script_entity_1 = require("./entities/core-script.entity");
let CoreScriptsService = class CoreScriptsService extends common_2.BaseService {
    constructor(model, coreScripts, moment_service) {
        super(model);
        this.model = model;
        this.coreScripts = coreScripts;
        this.moment_service = moment_service;
    }
    dashboardQuery(query, id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.coreScripts
                .findOne({
                where: { id: id },
            })
                .then((core) => __awaiter(this, void 0, void 0, function* () {
                let script = core.script;
                const body = query.body;
                if (core.input_parameters) {
                    const input = JSON.parse(core.input_parameters);
                    yield Promise.all(input.map((data) => __awaiter(this, void 0, void 0, function* () {
                        const field = data.field;
                        if (data.type === "date") {
                            const dates = yield this.moment_service.getDate(body[field], "YYYY-MM-DD HH:mm:ss");
                            script = script.replace(new RegExp("@" + field + ";", "g"), "'" + dates.start_day + "'");
                        }
                        else if (data.type === "string") {
                            script = script.replace(new RegExp("@" + field + ";", "g"), "'" + body[field] + "'");
                        }
                        else {
                            script = script.replace(new RegExp("@" + field + ";", "g"), body[field]);
                        }
                    })));
                }
                else {
                }
                return yield this.coreScripts.sequelize.query(script);
            }))
                .catch((error) => {
                console.log(error);
                return error;
            });
        });
    }
};
CoreScriptsService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.CORE_SCRIPTS)),
    __param(1, (0, common_1.Inject)(constants_1.CORE_SCRIPTS)),
    __metadata("design:paramtypes", [core_script_entity_1.CoreScript, Object, common_2.MomentUtilities])
], CoreScriptsService);
exports.CoreScriptsService = CoreScriptsService;
